function [theta_grid,K,iter_time,theta_ori,STEP,grid_number,backtracking_com,nonsci_Grad, Grad,back_plot] = DAGS_new_com(y,alpha,poles,grid_num)
%input
%y->data
%alpha->acceleration factor
%poles->sind(doa) This input is for plot, not necessary
%output
%theta_grid->estimated DOAs
%K->numbers of estimated DOAs
%iter_time->iteration times
%theta_ori->grids in each iteration
%STEP->gradient descent steps for each grid
%grid_number->numbers of grids in each iteration

iter_max=500;
theta_ori=zeros(grid_num,iter_max);
theta_grid=-90:181/(grid_num):90;
f_temp=sind(theta_grid);    
theta_ori(:,1)=theta_grid;

smp=1:size(y,1);
L=size(y,2);
epsilon=1e-3;
k=0;
iter=0;
grid_unchange=0;
grid_unchange_old=0;
grid_conv=0;
grad_change=zeros(10,iter_max);
Amp=zeros(grid_num,iter_max);
STEP=zeros(grid_num,iter_max);
FLAG=zeros(grid_num,iter_max);
flag_new=zeros(grid_num,iter_max);
flag_acc=0;
grid_number=zeros(iter_max,1);
Grad=zeros(grid_num,iter_max);
Theta_temp=zeros(grid_num,iter_max);
f_temp_old=f_temp;
construct_Error=zeros(iter_max,1);
backtracking_number=[];
Scientific_number=[];
backtracking_com=zeros(3,iter_max);
nonsci_Grad=[];
back_plot=zeros(length(theta_grid),500);
back_times=zeros(2,500);
back_unsci=zeros(length(theta_grid),1);
back_sci=zeros(length(theta_grid),1);
Alpha=[0,0.8,0.9,0.99,0.999];
record=zeros(length(Alpha),500);
CHAN=zeros(length(Alpha),500);
for ialpha=1:length(Alpha)
    alpha=Alpha(ialpha);
    theta_grid=-90:181/(grid_num):90;
f_temp=sind(theta_grid);                                                            %óʼȷ,ǶȻ
iter_max=500;
smp=1:size(y,1);
L=size(y,2);
epsilon=1e-3;
k=0;
iter=0;
grid_unchange=0;
grid_unchange_old=0;
grid_conv=0;
grad_change=zeros(10,iter_max);
Amp=zeros(grid_num,iter_max);
STEP=zeros(grid_num,iter_max);
FLAG=zeros(grid_num,iter_max);
flag_new=zeros(grid_num,iter_max);
flag_acc=0;
grid_number=zeros(iter_max,1);
Grad=zeros(grid_num,iter_max);
Theta_temp=zeros(grid_num,iter_max);
f_temp_old=f_temp;
construct_Error=zeros(iter_max,1);
backtracking_number=[];
Scientific_number=[];
backtracking_com=zeros(3,iter_max);
nonsci_Grad=[];
back_plot=zeros(length(theta_grid),500);
back_times=zeros(2,500);
back_unsci=zeros(length(theta_grid),1);
back_sci=zeros(length(theta_grid),1);
for iter=1:iter_max
    %     iter
    grid_number(iter)=length(f_temp);
    if length(f_temp)<2
        f_temp=ones(2,1);
        iter_time=iter_max;
        K=2;
        break
    end
    
    if iter==1
        x=ones(length(f_temp)+size(y,1),L);                                   
    else
        x_new=x_newplot.*ones(length(f_temp),L);                          
        x_new=x_new./norm(x_newplot);
    end
    clear w
    %% step 1
    if iter==1
        A=exp(-1j*pi*(smp-1)'.*f_temp);                    %f_temp sind value
        A_noise=eye(size(y,1));
        A_dic=A;
        A=[A,A_noise];
        sigma=1;
        x=inv(A'*A+sigma.*eye(size(A,2)))*A'*y;     
        for i=1:size(x,1)
            x_power(i,:)=x(i,:)*x(i,:)'/L;
        end
        x_power=x_power./max(x_power);
        sig_power=x_power(1:end-size(y,1));
        noise_power=mean(sig_power(end-19:end));     %This is an important threshold
        f_temp(sig_power(1:end-20)<noise_power)=-1.5;
        f_temp(f_temp==-1.5)=[];
        theta_grid(sig_power(1:end-20)<noise_power)=-1.5;
        theta_grid(theta_grid==-1.5)=[];
        x_ntemp=x(1:end-20,:);
        x_ntemp(sig_power(1:end-20)<noise_power,:)=-1;
        x_ntemp(x_ntemp(:,1)==-1,:)=[];
        sig_power(sig_power(1:end-20)<noise_power)=-1;
        sig_power(sig_power==-1)=[];
        for i=1:size(x_ntemp,1)
            x_newplot(i)=x_ntemp(i,:)*x_ntemp(i,:)'/L;
        end
        x_newplot=x_newplot./max(x_newplot);
        
        A=exp(-1j*pi*(smp-1)'.*f_temp);
        w=zeros(length(x_newplot),1);
        for wi=1:length(x_newplot)
            w(wi)=1./(abs(x_newplot(wi))^2+epsilon);
        end
        sigma=(norm(A,2)).^2;
        tao=1/sigma;
        x_ntemp=x_ntemp+tao*A'*(y-A*x_ntemp);
        
        for ii=1:size(x_ntemp,1)
            x_newplot(ii)=x_newplot(ii)+mean(abs(x_ntemp(ii,:)));
        end
        x_newplot=x_newplot./max(x_newplot);
        x_power=x_newplot.*x_newplot;
        
        index=[];
        k=0;
        for ii=1:length(x_power)
            if abs(x_power(ii))<noise_power         
                x_power(ii)=0;
                x_ntemp(ii,:)=0;
                f_temp(ii)=0;
                theta_grid(ii)=0;
                x_newplot(ii)=0;
                k=k+1;
                index(k)=ii;
            end
        end
        x_power(index)=[];
        theta_grid(index)=[];
        x_ntemp(index,:) = [];
        f_temp(index)=[];
        x_newplot=nonzeros(x_newplot);
        
        %         figure;
        %         stem(theta_grid,x_newplot,'b','LineWidth',1);                     %cutx_newͼ
        %         hold on
        %         stem(asind(poles),ones(length(poles),1)*max(x_newplot),'r^','LineWidth',1);
        %         legend('estimated','true')
        %         %             title('The 1st Iteration')
        %         xlabel('sind value');
        %         ylabel('Amplitude');
        %         xlim([-90,90]);
        %         set(gca,'Fontsize',20)
        %         grid on
        %
        w=zeros(size(x,1),1);
        A=exp(-1j*pi*(smp-1)'.*f_temp);
        construct_Error(iter)=norm(y-A*x_ntemp,'fro');
    else
        
        %         if f_temp_old==f_temp
        
        if size(f_temp,2)<size(f_temp,1)
            f_temp=f_temp';
        end
        A=exp(-1j*pi*(smp-1)'.*f_temp);
        sigma=(norm(A,2)).^2;
        tao=1/sigma;
        
        if length(f_temp_old)==length(f_temp)
            for wi=1:length(x_newplot)
                x_newplot_temp=x_newplot./max(x_newplot);
                w(wi)=1./(abs(x_newplot_temp(wi))^2+epsilon);    
            end
            
            for i=1:length(w)
                if w(i)>100
                    w(i)=w(i)/10;
                end
            end
        elseif length(f_temp_old)>length(f_temp)
            x_newplot=ones(length(f_temp),1);
            x_newplot_temp=x_newplot./max(x_newplot);
            for wi=1:length(x_newplot)
                w(wi)=1./(abs(x_newplot(wi))^2+epsilon);
            end
        end
        
        
        
        
        
        xnew_temp=x_new+tao*A'*(y-A*x_new);
        for i=1:size(x_new,1)
            x_new(i,:)=(1/(1+(tao*w(i)*w(i)))).*xnew_temp(i,:);
        end
        x_newplot=zeros(size(x_new,1),1);
        for ii=1:size(x_new,2)
            x_newplot=x_newplot+abs(x_new(:,ii));
        end
        x_newplot=x_newplot/L;
        x_newplot=x_newplot./max(x_newplot);
        
        
        index=[];
        k=0;
        for ii=1:length(x_newplot)
            if abs(x_newplot(ii))<noise_power
                x_new(ii,:)=0;
                f_temp(ii)=0;
                theta_grid(ii)=0;
                x_newplot(ii)=0;
                k=k+1;
                index(k)=ii;
            end
        end
        theta_grid(index)=[];
        x_new(all(x_new==0,2),:) = [];
        f_temp(index)=[];
        x_newplot=nonzeros(x_newplot);
        if size(f_temp,2)<size(f_temp,1)
            f_temp=f_temp';
        end
        A=exp(-1j*pi*(smp-1)'.*f_temp);
        grad=zeros(size(x_new,1),1);
        grad_acc=zeros(size(x_new,1),1);
        flag=zeros(length(grad),1);
        scientific_flag=zeros(length(grad),1);
        clear theta_temp
        
        if size(f_temp,2)<size(f_temp,1)
            f_temp=f_temp';
        end
        A=exp(-1j*pi*(smp-1)'*f_temp);
        old_res=trace((y-A*x_new)'*(y-A*x_new));
        
        %% step 3
        theta_ind=zeros(64,500);
        grad_ori=zeros(length(grad),1);
        for g=1:length(grad)
            indstep=1;
            grad_flag=0;
            A_temp=zeros(size(A));
            theta_temp=zeros(size(theta_grid));
            theta_temp=theta_grid;
            B=zeros(length(smp),length(f_temp));
            B(:,g)=-1j*pi*(smp-1)'.*cosd(theta_temp(g));
            A_temp=A;
            grad(g)=2*real(trace(((A*x_new)'-y')*(B.*A_temp)*x_new));        
            grad_ori(g)=(grad(g));
            theta_nonacc=theta_grid;
            
            
            nonsci_Grad(g,iter)=grad(g);
            while abs(grad(g))>10
                grad(g)=grad(g)/10;
                grad_flag=grad_flag+1;
                scientific_flag(g)=scientific_flag(g)+1;
            end
            
            if (grid_conv==1)&&(sign(grad_old(g))==sign(grad(g)))&&(length(grad_old)==length(grad))
                flag_acc=1;
            else flag_acc=0;
            end
            
            if (grid_unchange==1)&&(flag_acc==1)
                step=1/10.^(flag_old(g));
                theta_temp(g)=theta_grid(g)-alpha*step*grad_old(g);     
                
                theta_ind(g,indstep)=  theta_temp(g);
                indstep=indstep+1;
                
                theta_grid(g)=theta_temp(g);
                A_temp_acc=zeros(size(A));
                theta_temp_acc=zeros(size(theta_grid));
                theta_temp_acc=theta_grid;
                B_acc=zeros(length(smp),length(f_temp));
                B_acc(:,g)=-1j*pi*(smp-1)'.*cosd(theta_temp_acc(g));
                A_temp_acc=A;
                grad_acc(g)=2*real(trace(((A*x_new)'-y')*(B_acc.*A_temp_acc)*x_new));        
                if sign(grad_acc(g))==sign(grad(g))
                    while abs(grad_acc(g))>10
                        grad_acc(g)=grad_acc(g)/10;
                    end
                    grad(g)=grad_acc(g);
                else theta_grid(g)=theta_nonacc(g);
                end
            end
            
            %% 
            
         
            A_new=A;
                step=1;
            theta_temp(g)=theta_grid(g)-step*grad(g);
            A_new(:,g)=exp(-1j*pi*(smp-1)'.*sind(theta_temp(g)));
            new_res=trace((y-A_new*x_new)'*(y-A_new*x_new));
            while (old_res-new_res<0) | (old_res-new_res==0) && flag(g)<=10
                
                step=1/10*step;
                
                theta_temp(g)=theta_grid(g)-step*grad(g);
                
                theta_ind(g,indstep)=  theta_temp(g);
                indstep=indstep+1;
                %                 end
                A_new(:,g)=exp(-1j*pi*(smp-1)'.*sind(theta_temp(g)));
                new_res=trace((y-A_new*x_new)'*(y-A_new*x_new));
                flag(g)=flag(g)+1;
            end
            
            theta(g)=theta_temp(g);
            f_temp(g)=sind(theta(g));
            Grad(g,iter)=grad(g);
            STEP(g,iter)=step;
            Theta_temp(g,iter)=theta_temp(g);
            clear A_new
        end
                
        backtracking_number(iter)=sum(flag);
        non_accleration(iter)=sum(flag)+sum(scientific_flag);
        
        
        clear g
        [theta,ind]=sort(theta,'ascend');
        theta_grid=theta;
        
        xnew=zeros(size(x_new));
        for i=1:length(ind)
            xnew(i,:)=x_new(ind(i),:);
        end
        x_new=xnew;
        x_newplot=zeros(size(x_new,1),1);
        for ix=1:size(x_new,2)
            x_newplot=x_newplot+abs(x_new(:,ix));
        end
        
        x_newplot=x_newplot/L;
        f_temp=sind(theta_grid);
        
        
        if size(f_temp,2)<size(f_temp,1)
            f_temp=f_temp';
        end
        A_new=exp(-1j*pi*(smp-1)'.*f_temp);
        A=A_new;
        theta_ori(1:length(theta_grid),iter)=theta_grid;
        
        cut_Ind=[];
        cut_flag=0;
        for t=1:length(theta_grid)-1
            if abs(theta_grid(t+1)-theta_grid(t))<2         
                if (x_newplot(t+1)-x_newplot(t))<0
                    cut_flag=cut_flag+1;
                    cut_Ind(cut_flag)=t+1;
                else
                    cut_flag=cut_flag+1;
                    cut_Ind(cut_flag)=t;
                end
            end
        end
        
        x_newplot(cut_Ind)=0;
        theta_grid(cut_Ind)=0;
        theta_grid=nonzeros(theta_grid);
        x_newplot=nonzeros(x_newplot);
        f_temp=sind(theta_grid);
        
      
        f_temp=sort(f_temp,'ascend');
        if iter>2
            stop_flag=0;       %ÿgridı仯ǷС1e-4
            if length(f_temp_old)==length(f_temp)
                x_newplot_temp=x_newplot./max(x_newplot);
                grid_unchange=1;
                for f=1:length(f_temp)
                    if abs(theta_grid_old(f)-theta_grid(f))<1e-4 && abs(x_newplotold(f)-x_newplot_temp(f))<1e-3
                        stop_flag= stop_flag+1;
                    end
                end
            else grid_unchange=0;      %ϴgrid numberǷһ
            end
            if  stop_flag==length(f_temp)        %ֹͣж
                K=length(f_temp);
                iter_time=iter;
                break;
            end
        end
        
        if  grid_unchange==1  %ûб
            grid_conv=1;
            grad_old=grad;       %Բ
            flag_old=flag;            grid_conv=1;
            grad_old=grad;       %Բ
            flag_old=flag;
            grad_change(1:length(grad),iter)=grad;
            grad_change(length(grad)+1:length(grad)+length(flag),iter)=flag;
        end
        f_temp_old=f_temp;
        theta_grid_old=theta_grid;
        clear ind
        clear theta
        grid_unchange_old=grid_unchange;
        
        
        if max(x_newplot)>1 | flag_acc==1
            x_newplot=x_newplot./max(x_newplot);  % ø
        end
        x_newplotold=x_newplot;
            grad_change(1:length(grad),iter)=grad;
            grad_change(length(grad)+1:length(grad)+length(flag),iter)=flag;
        end
        f_temp_old=f_temp;
        theta_grid_old=theta_grid;
        clear ind
        clear theta
        grid_unchange_old=grid_unchange;
        
        
        if max(x_newplot)>1 | flag_acc==1
            x_newplot=x_newplot./max(x_newplot);  % ø
        end
        x_newplotold=x_newplot;
        construct_Error(iter)=norm(y-A*x_new,'fro');
    end
end
record(ialpha,:)=theta_ori(1,:);
CHAN(ialpha,:)=STEP(1,:).*Grad(1,:);
end

grid_number=nonzeros(grid_number);
if iter==iter_max
    clear f_temp K iter_time
    theta_grid= theta_grid;
    K=length(theta_grid);
    iter_time=iter_max;
end
end


